variables:
  MONGO_INITDB_ROOT_USERNAME: "admin"
  MONGO_INITDB_ROOT_PASSWORD: "admin"

default:
  image: node:16.13.0

  before_script:
    - "[ ! -f package-lock.json ] && npm i"
    - npm ci --cache .npm --prefer-offline

  cache:
    key: $CI_COMMIT_REF_SLUG
    paths:
      - .npm/

workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS'
      when: never
    - if: '$CI_COMMIT_BRANCH'

stages:
  - audit
  - build
  - test

audit-job:
  stage: audit
  script:
    - npm audit --audit-level=high

lint-job:
  stage: build
  script:
    - npm run lint

build-job:
  stage: build
  script:
    - npm run build

test-job:
  stage: test
  script:
    - mkdir -p keys
    - ssh-keygen -t rsa -b 1024 -m PEM -f ./keys/rpga_rsa.key -q -N ""
    - openssl rsa -in ./keys/rpga_rsa.key -pubout -outform PEM -out ./keys/rpga_rsa.key.pub
    - npm run test:ci
  services:
    - name: mongo:4.4
      alias: mongodb
    - name: rabbitmq:3.9.15
      alias: rabbitmq
  artifacts:
    reports:
      # Attach coverage to MRs
      cobertura: coverage/cobertura-coverage.xml
